Imports System.Runtime.InteropServices

Public Class Form1
    Private Declare Function SetForegroundWindow Lib "user32" (ByVal hWnd As IntPtr) As Boolean
    Private Declare Sub keybd_event Lib "user32" (ByVal bVk As Byte, ByVal bScan As Byte, ByVal dwFlags As Integer, ByVal dwExtraInfo As Integer)
    Private Const VK_SNAPSHOT As Short = &H2CS

    Public Overloads Declare Function GetWindowRect Lib "User32" Alias "GetWindowRect" (ByVal hWnd As IntPtr, ByRef lpRect As RECT) As Int32
    <StructLayout(LayoutKind.Sequential)> _
        Public Structure RECT
        Public Left As Integer
        Public Top As Integer
        Public Right As Integer
        Public Bottom As Integer
    End Structure

    Private Sub btnGo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGo.Click
        Dim target As String = txtProgram.Text.ToLower()
        For Each proc As Process In Process.GetProcesses()
            ' See if this is the target program.
            If proc.ProcessName.ToLower().Contains(target) Then
                ' We found it. Take its picture.
                dim bm as Bitmap=GetProgramImage(proc.MainWindowHandle)
                picImage.Image = bm
                Exit For
            End If
        Next proc
    End Sub

    ' Return a program's image.
    Private Function GetProgramImage(ByVal handle As IntPtr) As Image
        ' Bring it to the top.
        SetForegroundWindow(handle)

        ' Get the desktop image.
        Dim desktop_bm As Bitmap = GetDesktopImage()

        ' Find the program's window.
        Dim program_rect As RECT
        GetWindowRect(handle, program_rect)

        ' Copy that part of the desktop image.
        Dim wid As Integer = program_rect.Right - program_rect.Left
        Dim hgt As Integer = program_rect.Bottom - program_rect.Top
        Dim dest_rect As New Rectangle(0, 0, wid, hgt)
        Dim src_rect As New Rectangle(program_rect.Left, program_rect.Top, wid, hgt)
        Dim new_bm As New Bitmap(wid, hgt)
        Using gr As Graphics = Graphics.FromImage(new_bm)
            gr.DrawImage(desktop_bm, dest_rect, src_rect, GraphicsUnit.Pixel)
        End Using

        Return new_bm
    End Function

    ' Return the desktop image.
    Private Function GetDesktopImage() As Image
        keybd_event(System.Windows.Forms.Keys.Snapshot, 0, 0, 0)
        System.Threading.Thread.Sleep(200)

        If Clipboard.ContainsImage() Then Return Clipboard.GetImage()
        Return Nothing
    End Function
End Class
